import os
import shutil as sh
import time
import numpy as np
import win32com.client
from scipy.optimize import minimize
from scipy.optimize import fsolve

# import win32gui
# import win32console
# win=win32console.GetConsoleWindow()       # For closing command window
# win32gui.ShowWindow(win,0)




# popisovani 1-2-3 = 1 poradi 2 podelniky 3 iter

# po skoseni doma potraba povolit afgrow v referencich ve VBA

def hledej_podpis(searched_str, file_input, to_write1, por):
##vyhledavani a zapisovani v textu
## vyrobi radek pod vahledavanym
    line_number = 0
    line_searched = -1

    to_write = str(to_write1)+'\n'
    filtuple =os.path.splitext(file_input)
    filname = str(filtuple[0]+str(por))
    filext = str(filtuple[1])
    file_output = filname+filext
    input = open(file_input,'r')
    output = open(file_output,'w')

    for line_no, line in enumerate(input):
            line_number += 1
            if searched_str in line:
                line_searched = line_number
            if line_no == line_searched:
               output.write(to_write)
            output.write(line)
    input.close()
    output.close()

def hledej_prepis(searched_str, file_input, to_write1, por):
##vyhledavani a zapisovani v textu
## vyrobi radek misto vahledavanym
    line_number = 0
    line_searched = -1

    to_write = str(to_write1)+'\n'

    filtuple =os.path.splitext(file_input)
    filname = str(filtuple[0]+str(por))
    filext = str(filtuple[1])

    file_output = filname+filext
    input = open(file_input,'r')
    output = open(file_output,'w')

    for line_no, line in enumerate(input):
            if searched_str in line:
                line_searched = line_number
            if line_no == line_searched:
               output.write(to_write)
            else:
                output.write(line)
            line_number +=1
    input.close()
    output.close()

def presun(filelist, cilsl):
    #zkopiruje a original necha
    #filelist = [file1, file2 ...]
    #cilsl = cilova slozka
    for f in filelist:
        sh.copy(f, cilsl)

def zvypaprejm(filnama, filcila):
    #presune soubor z OUT do vybrane slozky a oddela zacatek
    filnam = str(filnama)
    filcil = str(filcila)

    filbase = '//L270/share/OUT'
    filcest = os.listdir(filbase)
    filhla = []
    filhl = []
    for file in filcest:
        if file.endswith(filnam):
            filhla.append(file)
    for file in filhla:
        filnn = filbase +'/'+ file
        filhl.append(filnn)

    for file in filhl:
        sh.move(file,filcil)
    filren = os.listdir(filcil)
    for file in filren:
        filspl = file.rsplit('_', 1)
        filename = filspl[-1]
        filsindir = filcil + '/' + file
        filcondir = filcil + '/' + filename
        try:
            os.rename(filsindir, filcondir)
        except WindowsError:
            os.remove(filcondir)
            os.rename(filsindir, filcondir)

def existujesoubor(file_loc):
    while not os.path.exists(file_loc):
        time.sleep(30)
    else: pass

def zmentl(file_input, pidpot, pidpod, pidcr, tlpota, tlpoda, por):
    #por je iterace
    line_number = 0
    line_searched1 = -1
    line_searched2 = -1
    delft = 5 - len(str(int(tlpota)))
    delfd = 5 - len(str(int(tlpoda)))
    
    formt = '.' + str(int(delft)) + 'f'
    formd = '.' + str(int(delfd)) + 'f'

    tlpotb = float(format(tlpota,'.2f'))
    tlpodb = float(format(tlpoda,'.2f'))
    tlpot = str(format(tlpotb, formt))
    tlpod = str(format(tlpodb, formd))

    searched_str1 = 'PSHELL         '+str(pidpot)
    searched_str2 = 'PSHELL         '+str(pidpod)
    searched_str3 = 'PRAC2D         '+str(pidcr)

    filtuple = os.path.splitext(file_input)
    filname = str(filtuple[0]+ '-' +str(por))
    filext = str(filtuple[1])

    file_output = filname + filext
    input = open(file_input, 'r')
    output = open(file_output, 'w')
    for line_no, line in enumerate(input):
        if searched_str1 in line:
            lnpred1 = line[:15]
            lnpid1 = line[15:17]
            lnpt1 = line[17:25]
            lntl1 = line[26:32]
            lnkon1 = line[32:]
            lnc1 = lnpred1 + lnpid1 + lnpt1 + ' ' + tlpot + lnkon1
            output.write(lnc1)
            line_number += 1
        elif searched_str2 in line:
            lnpred2 = line[:15]
            lnpid2 = line[15:17]
            lnpt2 = line[17:25]
            lntl2 = line[26:32]
            lnkon2 = line[32:]
            lnc2 = lnpred2 + lnpid2 + lnpt2 + ' ' + tlpod + lnkon2
            output.write(lnc2)
            line_number += 1
        elif searched_str3 in line:
            lnpred3 = line[:15]
            lnpid3 = line[15:17]
            lnpt3 = line[17:25]
            lntl3 = line[26:32]
            lnkon3 = line[32:]
            lnc3 = lnpred3 + lnpid3 + lnpt3 + ' ' + tlpot + lnkon3
            output.write(lnc3)
            line_number += 1
        else:
            output.write(line)
            line_number += 1

    input.close()
    output.close()

def napeti0(file_input, elemnumber):
    #vypise napeti HMH na cisle elementu(pro sol 101)
    searched_str = '0' + (8 - len(str(elemnumber)))*' ' + str(elemnumber)
    line_number = 0
    line_searched = -1

    input = open(file_input,'r')

    for line_no, line in enumerate(input):
            line_number += 1
            if searched_str in line:
                line_searched = line_number
            if line_no == line_searched:
                try:nap0 = float(line[119:132])
                except ValueError:pass
    input.close()
    return(nap0)

def beta(file_input, sigmaa, acra):
    #vypise napeti HMH na cisle elementu(pro sol 101)
    #MPa, mm
    #mozna predelat na auto ziskani delky
    searched_str = 'S6'
    line_number = 0
    line_searched = -1
    acr= float(acra)
    sigma = float(sigmaa)

    input = open(file_input,'r')

    for line_no, line in enumerate(input):
            line_number += 1
            if searched_str in line:
                line_searched = line_number
            if line_no == line_searched:
               k1 = float(line[82:94])
               k2 = float(line[94:107])
               k= ((k1**2+k2**2)**0.5)/(1000**0.5)
               bett = k/(sigma*(np.pi*acr)**0.5)
               return(bett)
    input.close()

def silcbush(filin, id):
    searched_str = '0' + (27 - len(str(id))) * ' ' + str(id)
    line_number = 0
    line_searched = -1
    input = open(filin, 'r')

    for line_no, line in enumerate(input):

        if searched_str in line:
            line_searched = line_number
        if line_no == line_searched:
            try:
                sila = (float(line[34:46])**2 + float(line[48:60])**2 + float(line[62:74])**2)**0.5
            except ValueError:
                pass
        line_number += 1
    input.close()
    return (sila)

def betlist(filloc, filpr, nam, por, podelniku, tpota, tpoda, pidpot, pidpod, selem, souboru, pidcr, selemh, scbush):
#vypise tabulku acrack / beta, trva asi pul hod
    hlaseni('pracuju s naskama')

    for i in range (souboru):
        fil0 = str(filloc) + '/' + str(i)+ '-' + str(nam) + '.nas'
        if os.path.exists(fil0):
            fil1 = str(filloc) + '\\' + str(i) + '-' + str(nam) + '-' +str(por) +'.nas'
            zmentl(fil0, pidpot, pidpod, pidcr, tpota, tpoda, por)
            sh.move(fil1, '//L270/share/IN/')
            time.sleep(10)
            i =+ 1
        else: print('chybi nasky')


    fil2 = '//L270/share/OUT/' + str(souboru-1) + '-' + str(nam) + '-' + str(por) + '.nas'
    # kontroluju jenom posledni, ten time.sleep zajistuje rozestupy na udrzedni poradi
    hlaseni('cekam na vyreseni')
    i=0
    k=0
    while i==0:
        fillist = os.listdir('//L270/share/OUT/')
        for file in fillist:
            if (str(souboru-1) + '-' + str(nam) + '-' + str(por)) in file:
                i = 1
        time.sleep(30)
        k += 1
        hlaseni('cekam ' + str(k*0.5) + ' minut')


    #predpokladam vsechny vyresene
    hlaseni('ziskavam f06')
    for i in range (souboru):
        fil3 =  str(i) + '-' + nam + '-' + str(por)
        cil = filpr
        zvypaprejm(fil3, cil)
        time.sleep(10)

    fil4 = filpr +'//' + '0' + '-' + str(int(nam)) + '-' + str(int(por)) + '//' + '0' + '-' + str(int(nam)) + '-' + str(int(por)) + '.f06'
    sigma0 = napeti0(fil4, selem)
    sigma0h = napeti0(fil4, selemh)
    cbushsil = silcbush(fil4, scbush)

    xl = win32com.client.Dispatch("Excel.Application")

    koefvz = xl.Worksheets('Baseparam').Cells(9,5).Value
    skrvz = xl.Worksheets('Baseparam').Cells(9,21).Value
    bezpvz = abs(skrvz/(sigma0*koefvz))

    xl.Worksheets('Baseparam').Cells(11,3).Value = sigma0
    xl.Worksheets('Baseparam').Cells(21, 9+int(por)).Value = sigma0
    xl.Worksheets('Baseparam').Cells(22, 9+int(por)).Value = sigma0h
    xl.Worksheets('Baseparam').Cells(23, 9+int(por)).Value = bezpvz
    xl.Worksheets('Baseparam').Cells(10, 3).Value = cbushsil



    rozx = souboru
    rozy = 11
    tabacrack = np.ones((rozy,rozx))

    for i in range (rozy):
        for j in range (rozx):
            tabacrack[i,j] = xl.Worksheets('Beta').Cells(i+2,j+7).Value
            j =+1
        i=+1

    bet = np.ones((souboru-1,2))
    for i in range(souboru-1):
        fil5 = filpr +'//' + str(i+1) + '-' + nam + '-' + str(por) + '//' + str(i+1) + '-' + nam + '-' + str(por) + '.f06'
        bet[i,0] = tabacrack[int(podelniku)-4, i+1]
        bet[i,1] = beta(fil5, sigma0, bet[i,0])
    hlaseni('bety hotovo')
    return bet

def vypisbet (bettab):
    xl = win32com.client.Dispatch("Excel.Application")
    for i in range(len(bettab)):
        xl.Worksheets('Beta').Cells(i+2, 2).Value = bettab[i,0]
        xl.Worksheets('Beta').Cells(i+2, 3).Value = bettab[i,1]

def getparam():
    #ziskani param z ovladacího excelu, pristup pres getparam()[i]
    xl = win32com.client.Dispatch("Excel.Application")
    #xl.Visible = True
    filloc = xl.Worksheets('Baseparam').Cells(4,9).Value
    filpr = xl.Worksheets('Baseparam').Cells(5,9).Value
    nam = str(int(xl.Worksheets('Baseparam').Cells(1,3).Value))
    por = str(int(xl.Worksheets('Baseparam').Cells(20,7).Value))
    podelniku = nam
    tpota = xl.Worksheets('Baseparam').Cells(2,3).Value
    tpoda = xl.Worksheets('Baseparam').Cells(3,3).Value
    pidpot = int(xl.Worksheets('Baseparam').Cells(2,5).Value)
    pidpod = int(xl.Worksheets('Baseparam').Cells(3,5).Value)
    selem = int(xl.Worksheets('Baseparam').Cells(4,5).Value)
    dia = xl.Worksheets('Baseparam').Cells(6,3).Value
    off = xl.Worksheets('Baseparam').Cells(7,3).Value
    hpod = xl.Worksheets('Baseparam').Cells(1,5).Value
    pozziv = xl.Worksheets('Baseparam').Cells(5,5).Value
    bezp = xl.Worksheets('Baseparam').Cells(6,5).Value
    souboru = int(xl.Worksheets('Baseparam').Cells(1,9).Value)
    pidcr = int(xl.Worksheets('Baseparam').Cells(7,5).Value)
    adet = xl.Worksheets('Baseparam').Cells(8, 5).Value / 1000
    selemh = int(xl.Worksheets('Baseparam').Cells(4,6).Value)
    selbush = int(xl.Worksheets('Baseparam').Cells(10,5).Value)

    return filloc, filpr, nam, por, podelniku, tpota, tpoda, pidpot, pidpod, selem, dia, off, hpod, pozziv, bezp, souboru, pidcr, adet, selemh, selbush

def getparamhm():
    xl = win32com.client.Dispatch("Excel.Application")
    hpod = xl.Worksheets('Baseparam').Cells(1,5).Value
    pod = xl.Worksheets('Baseparam').Cells(1,3).Value
    sirka = xl.Worksheets('Baseparam').Cells(4,3).Value
    iter = xl.Worksheets('Baseparam').Cells(20,7).Value
    return hpod, pod, sirka, iter

def trhfl(file_input, dia, off):
    #output je delka trhliny pri lomu lig a pocet cyklu
    my_file = open(file_input,"r").readlines()
    for i,line in enumerate(my_file):
        if i<5:
            pass
        else:
            if float(line[16:29]) == 0:
                line_sr = my_file[i-1]
                return (float(line_sr[17:31])+off+dia/2),(float(line_sr[389:400]))
                break

def zpracafl(acp1):
    xl = win32com.client.Dispatch("Excel.Application")
    xl.Worksheets('Baseparam').Cells(19,3).Value = acp1

def trhfp(file_input):
    #output je delka trhliny a pocet cyklu od 1
    with open(file_input) as f:
        for line in f:
            pass
    last_line = line
    return (float(last_line[2:12])), (float(last_line[215:229]))

def det(file_input2, trhfla, adet):
    if adet < trhfla[0]:
        return('je v prvni casti')
    else:
        my_file = open(file_input2, "r").readlines()
        for i, line in enumerate(my_file):
            if i < 5:
                pass
            else:
                if float(line[1:11]) > adet:
                    line_sr = my_file[i-1]
                    return (float(line_sr[2:12])), (float(line_sr[215:229]) + trhfla[1])

def giveloc():
    xl = win32com.client.Dispatch("Excel.Application")
    lloc = xl.Worksheets('Baseparam').Cells(8,9).Value
    ploc = xl.Worksheets('Baseparam').Cells(9,9).Value
    return lloc, ploc

def giveparam(tpot, tpod):
    xl = win32com.client.Dispatch("Excel.Application")
    xl.Worksheets('Baseparam').Cells(2,3).Value = tpot
    xl.Worksheets('Baseparam').Cells(3,3).Value = tpod

def pridejiter():
    xl = win32com.client.Dispatch("Excel.Application")
    xl.Worksheets('Baseparam').Cells(20,7).Value += 1

def hlaseni(zprava):
     xl = win32com.client.Dispatch("Excel.Application")
     xl.Worksheets('Baseparam').Cells(21,7).Value = str(zprava)

def afl():
     xl = win32com.client.Dispatch("Excel.Application")
     xl.Application.Run('Module1.levaf')

def afp():
    xl = win32com.client.Dispatch("Excel.Application")
    xl.Application.Run('Module1.pravaf')

def kvzper(file_input):
    #vypise bezpecnost na vzper sol105
    searched_str = '      EIGENVALUE ='
    line_number = 0
    line_searched = -1
    xl = win32com.client.Dispatch("Excel.Application")
    koef = xl.Worksheets('Baseparam').Cells(9, 5).Value
    input = open(file_input,'r')

    for line_no, line in enumerate(input):
            if searched_str in line:
                line_searched = line_number
            if line_no == line_searched:
                eig0 = float(line[18:35])
                break
            line_number += 1
    input.close()
    return(eig0/koef)

def Srez(acr):
    #vypisuje zbylou plochou pro danou delku trhliny
    def getinfo():
        xl = win32com.client.Dispatch("Excel.Application")
        len = float(xl.Worksheets('Baseparam').Cells(4, 3).Value)
        tpod = float(xl.Worksheets('Baseparam').Cells(3, 3).Value)
        spapod = float(xl.Worksheets('Baseparam').Cells(12, 5).Value)
        hpod = float(xl.Worksheets('Baseparam').Cells(1, 5).Value)
        prmez = float(xl.Worksheets('Baseparam').Cells(13, 5).Value)
        tpot = float(xl.Worksheets('Baseparam').Cells(2, 3).Value)

        return len, tpod, spapod, hpod, prmez, tpot

    paramS = getinfo()
    len = paramS[0]
    tpod = paramS[1]
    spapod = paramS[2]
    hpod = paramS[3]
    prmez = paramS[4]
    tpot = paramS[5]

    Scel = tpot * len + (len - 2 * prmez) / spapod * tpod * hpod

    def vpod(acr, spapod, hpod, prmez):
        delzap = (acr - prmez) % spapod
        if delzap < hpod and (acr - prmez) // spapod > 0:
            return hpod - delzap
        else:
            return 0

    def zacatek(acr, prmez):
        if acr - prmez < 0:
            return 0
        else:
            return acr - prmez

    Szbyt = Scel - (acr * tpot + (zacatek(acr, prmez)) // spapod * tpod * hpod - vpod(acr, spapod, hpod, prmez) * tpod)

    return (Szbyt / Scel)

def sigmarezacr():
    #vyresi kritickou delku trhliny kdy je s0>Re
    xl = win32com.client.Dispatch("Excel.Application")
    s0 = float(xl.Worksheets('Baseparam').Cells(11, 3).Value)
    Re = float(xl.Worksheets('Baseparam').Cells(14, 5).Value)
    len = float(xl.Worksheets('Baseparam').Cells(4, 3).Value)

    def Srezupr(acr):
        return Srez(acr) - (s0 * 3.133 / Re)

    x0 = len * (1 - s0 * 3.133 / Re)
    soll = fsolve(Srezupr, x0) # numericky acrit
    return soll[0]

def unstableacr():
    xl = win32com.client.Dispatch("Excel.Application")
    kc = float(xl.Worksheets('Baseparam').Cells(15, 5).Value)
    souboru = int(xl.Worksheets('Baseparam').Cells(1, 9).Value)
    s0 = float(xl.Worksheets('Baseparam').Cells(11, 3).Value)
    ktable = np.ones((souboru, 2))
    for i in range(souboru - 1):
        ktable[i,0] = xl.Worksheets('Beta').Cells(i + 2, 2).Value
        ktable[i,1] = xl.Worksheets('Beta').Cells(i + 2, 3).Value * (ktable[i,0] * np.pi)**(1/2) *s0
        xl.Worksheets('Beta').Cells(i + 2, 4).Value = ktable[i,1]

    #posledni, hodne velikej
    ktable[souboru - 1, 0] = 3 * ktable[souboru - 2, 0]
    ktable[souboru - 1, 1] = ktable[souboru - 2, 1] * 3**1/2

    j = 0
    while ktable[j,1] < kc and j<(souboru - 1):
        j += 1

    acrunst = ktable[j,0]
    return(acrunst)

def cykltrh(file_input2, acr):
    my_file = open(file_input2, "r").readlines()
    for i, line in enumerate(my_file):
        if i < 5:
            pass
        else:
            if float(line[1:11]) > acr:
                line_sr = my_file[i-1]
                return (float(line_sr[2:12])), (float(line_sr[215:229]))

def vysl(cykll, cyklp, acrack):
    cykl = cykll + cyklp
    acr = acrack
    acrnestab = unstableacr()
    acrsigma = sigmarezacr()
    if acr == min(acr,acrnestab, acrsigma):
        return cykl, acr
    else:
        acrit = min(acr,acrnestab, acrsigma)
        locc = giveloc()
        cyklpp = cykltrh(locc[1], acrit)
        cykkrit = cykll + cyklpp[1]
        return cykkrit, acrit

def hm(t):
    tpot = t[0]
    tpod = t[1]
    paramhm = getparamhm()
    hpod = paramhm[0]
    pod = paramhm[1]
    sirka = paramhm[2]
    iter = paramhm[3]
    hmotnost = tpot/1000*sirka + tpod/1000*hpod*pod
    return hmotnost

def zivot(t):
#vypocte vydrz
    tpot = t[0]
    tpod = t[1]

    xl = win32com.client.Dispatch("Excel.Application")
    iter =  int(xl.Worksheets('Baseparam').Cells(20, 7).Value)

    tpotm = xl.Worksheets('Baseparam').Cells(15, 9 + int(iter) - 1).Value
    tpodm = xl.Worksheets('Baseparam').Cells(16, 9 + int(iter) - 1).Value
    mode = int(xl.Worksheets('Baseparam').Cells(24,7).Value)

    if tpotm == tpot and tpodm == tpod and mode == 2 or mode == 3:
            xl.Worksheets('Baseparam').Cells(14, 9 + int(iter)).Value = iter
            pozziv = xl.Worksheets('Baseparam').Cells(5, 5).Value
            bezp = xl.Worksheets('Baseparam').Cells(6, 5).Value
            ziv0 = pozziv * bezp

            return (xl.Worksheets('Baseparam').Cells(18, 9 + int(iter) - 1).Value - ziv0)

    else:
        giveparam(tpot/1000, tpod/1000)  #napise nove hodnoty tloustek do excelu
        hlaseni('ziskavam parametry')
        param0 = getparam()   #ziska parametry z excelu
        bettable = betlist(param0[0], param0[1], param0[2], param0[3], param0[4], param0[5]*1000, param0[6]*1000, param0[7], param0[8], param0[9], param0[15], param0[16], param0[18], param0[19])
                                #vypocte tabulku delka trhliny / beta funkce
        vypisbet(bettable)      #vypise tabulu bet do excelu
        loc = giveloc()         #vypise lokace vysledku
        hlaseni('afgrow p1')
        afl()                   #vypocet trhliny do lomu ligamentu
        existujesoubor(loc[0])  #pocka na vyreseni afl
        trh1 = trhfl(loc[0], param0[10], param0[11]) #ziska delku trhily pri lomu lig
        zpracafl(trh1[0])       #zapise predchozi do excelu
        hlaseni('afgrow p2')
        time.sleep(200)
        afp()                   #druha cast vypoctu v af
        existujesoubor(loc[1])  #pocka na vyreseni afp
        trh2 = trhfp(loc[1])    #ziska param trhilny
        trhf = vysl(trh1[1],trh2[1],trh2[0])
        ddet = det(loc[1], trh1 ,param0[17])
        hlaseni('iterace hotova')
        ziv0 = param0[13]*param0[14]

        # vypis aktualnich param do excelu
        xl = win32com.client.Dispatch("Excel.Application")
        iter = param0[3]

        xl.Worksheets('Baseparam').Cells(14, 9 + int(iter)).Value = int(iter)
        xl.Worksheets('Baseparam').Cells(15, 9 + int(iter)).Value = tpot
        xl.Worksheets('Baseparam').Cells(16, 9 + int(iter)).Value = tpod
        xl.Worksheets('Baseparam').Cells(17, 9 + int(iter)).Value = hm(t)
        xl.Worksheets('Baseparam').Cells(18, 9 + int(iter)).Value = int(trhf[0])
        xl.Worksheets('Baseparam').Cells(19, 9 + int(iter)).Value = trhf[1]
        xl.Worksheets('Baseparam').Cells(20, 9 + int(iter)).Value = int(ddet[1])

        pridejiter()

        return (trhf[0]-ziv0)

def zivota(t):
#pro testovani bez nas a afg
    tpot = t[0]
    tpod = t[1]
    giveparam(tpot/1000, tpod/1000)  #napise nove hodnoty tloustek do excelu
    hlaseni('ziskavam parametry')
    param0 = getparam()   #ziska parametry z excelu
    #bettable = betlist(param0[0], param0[1], param0[2], param0[3], param0[4], param0[5]*1000, param0[6]*1000, param0[7], param0[8], param0[9], param0[15], param0[16], param0[18], param0[19])
                            #vypocte tabulku delka trhliny / beta funkce
    #vypisbet(bettable)      #vypise tabulu bet do excelu
    loc = giveloc()         #vypise lokace vysledku
    hlaseni('afgrow p1')
    afl()                   #vypocet trhliny do lomu ligamentu
    existujesoubor(loc[0])  #pocka na vyreseni afl
    trh1 = trhfl(loc[0], param0[10], param0[11]) #ziska delku trhily pri lomu lig
    zpracafl(trh1[0])       #zapise predchozi do excelu
    hlaseni('afgrow p2')
    #time.sleep(200)
    afp()                   #druha cast vypoctu v af
    existujesoubor(loc[1])  #pocka na vyreseni afp
    trh2 = trhfp(loc[1])    #ziska param trhilny
    trhf = vysl(trh1[1],trh2[1],trh2[0])
    ddet = det(loc[1], trh1 ,param0[17])
    hlaseni('iterace hotova')
    ziv0 = param0[13]*param0[14]

    # vypis aktualnich param do excelu
    xl = win32com.client.Dispatch("Excel.Application")
    iter = param0[3]

    xl.Worksheets('Baseparam').Cells(14, 9 + int(iter)).Value = iter
    xl.Worksheets('Baseparam').Cells(15, 9 + int(iter)).Value = tpot
    xl.Worksheets('Baseparam').Cells(16, 9 + int(iter)).Value = tpod
    xl.Worksheets('Baseparam').Cells(17, 9 + int(iter)).Value = hm(t)
    xl.Worksheets('Baseparam').Cells(18, 9 + int(iter)).Value = trhf[0]
    xl.Worksheets('Baseparam').Cells(19, 9 + int(iter)).Value = trhf[1]
    xl.Worksheets('Baseparam').Cells(20, 9 + int(iter)).Value = ddet[1]

    #pridejiter()

    return (trhf[0]-ziv0)

def grid():

    xl = win32com.client.Dispatch("Excel.Application")
    mint = xl.Worksheets('Baseparam').Cells(24,3).Value
    maxt = xl.Worksheets('Baseparam').Cells(25,3).Value
    mind = xl.Worksheets('Baseparam').Cells(26, 3).Value
    maxd = xl.Worksheets('Baseparam').Cells(27, 3).Value
    bodu = int(xl.Worksheets('Baseparam').Cells(29,3).Value)
    rozmt = (maxt - mint)/(bodu - 1)
    rozmd = (maxd - mind) / (bodu - 1)
    tpot = np.zeros(bodu)
    tpod = np.zeros(bodu)
    for i in range(bodu):
        tpot[i] = mint + i * rozmt
        tpod[i] = mind + i * rozmd
    hmot = np.zeros((bodu,bodu))
    ziv = np.zeros((bodu,bodu))

    for i in range(bodu):
        for j in range(bodu):
            hmot[i,j] = hm([tpot[i], tpod[j]])
            ziv[i,j] = zivot([tpot[i], tpod[j]])

    hli = bodu-1
    hlj = bodu-1
    for i in range(bodu):
        for j in range(bodu):
            if ziv[i , j] > 0 and hmot[i , j] < hmot[hli, hlj]:
                hli = i
                hlj = j
                print(i,j)
                print(hli, hlj)
    return tpot[hli], tpod[hlj]

def slsqp():
    xl = win32com.client.Dispatch("Excel.Application")
    x0 = np.zeros(2)
    x0[0] = xl.Worksheets('Baseparam').Cells(22,3).Value
    x0[1] = xl.Worksheets('Baseparam').Cells(23,3).Value
    bndt = (xl.Worksheets('Baseparam').Cells(24,3).Value,xl.Worksheets('Baseparam').Cells(25,3).Value)  #omezeni tloustky
    bndd = (xl.Worksheets('Baseparam').Cells(26,3).Value,xl.Worksheets('Baseparam').Cells(27,3).Value)
    bnds = (bndt,bndd)
    cons = ({'type': 'ineq', 'fun': zivot})
    eps = 0.1 #prvni skok
    sol = minimize(hm,x0,method='SLSQP', bounds=bnds, constraints=cons, options={'eps': eps})
    return sol.x

def main():
    xl = win32com.client.Dispatch("Excel.Application")
    mode = int(xl.Worksheets('Baseparam').Cells(24,7).Value)#cose bude dit
    if mode == 0:   #jenom jeden vypocet pro dane tpot a tpod
        x0 = np.zeros(2)
        x0[0] = xl.Worksheets('Baseparam').Cells(22,3).Value
        x0[1] = xl.Worksheets('Baseparam').Cells(23,3).Value
        zivot(x0)
        ziv = x0
    elif mode == 1: #gridova optim
        ziv = grid()
    elif mode == 2: #slsqp
        ziv = slsqp()
    elif mode == 3: #jeden grid pro dobre x0 a pak slsqp
        ziv1 = grid()
        xl.Worksheets('Baseparam').Cells(22,3).Value = ziv1[0]
        xl.Worksheets('Baseparam').Cells(23,3).Value = ziv1[1]
        ziv = slsqp()

    else: hlaseni('max mody jsou 1 2 a 3')
    xl.Worksheets('Baseparam').Cells(26,7).Value = ziv[0]
    xl.Worksheets('Baseparam').Cells(26,8).Value = ziv[1]
    hlaseni('optimalizace hotova')
    return(ziv)

if __name__ == '__main__':
    main()
